package com.thoughtworks.rettig.dataLoader;


import java.io.*;
import junit.framework.*;
import com.thoughtworks.rettig.util.*;

public class FooFileIteratorTest extends junit.framework.TestCase{

    private final static String FILELOC = "testFiles/reflection/";

    public FooFileIteratorTest(String test){
	super(test);

    }

    public static void main (String[] args) {
	       //junit.swingui.TestRunner.main(args);
	       junit.textui.TestRunner.run (suite());
    }

    public static Test suite() {
	       return new TestSuite(FooFileIteratorTest.class);
    }
  
    public void testIntegerFile()throws Exception{
	Integer num = (Integer) testFile(FILELOC+"Integer.txt", Integer.class);
	assertEquals(num.intValue(), 1);
    }

    public void testSubFooObject()throws Exception{
	SubFooObject subFoo = (SubFooObject) testFile(FILELOC+"SubFooObject.txt", SubFooObject.class);
	assertEquals(subFoo, new SubFooObject("input", 1));
    }

    public void testIntArray()throws Exception{
	int[] ints = (int[])testFile(FILELOC+"IntArray.txt", int[].class);
	assertEquals(ints, new int[]{1,2,3});
    }

    public void testFoo()throws Exception{
	FooObject foo = (FooObject) testFile(FILELOC+"FooDataFile.txt", FooObject.class);
	assertEquals(foo.getInt(), 1);
	assertEquals(foo.getString(), "data");
	assertEquals(foo.getSubFooObject(), new SubFooObject("input", 1));
	assertEquals(foo.getIntArray(), new int[]{1,2});

	SubFooObject sub1 = new SubFooObject("input", 1);
	SubFooObject sub2 = new SubFooObject("input", 2);
	SubFooObject sub3 = new SubFooObject("input", 3);
	assertEquals(foo.getSubFooObjectArray(), new SubFooObject[]{sub1, sub2, sub3});
    }

    public void assertEquals(SubFooObject[] sub1, SubFooObject[] sub2){
	assertEquals(sub1.length, sub2.length);
	for(int i = 0; i <sub1.length ; i++){
	    assertEquals(sub1[i], sub2[i]);
	}
    }

    public void assertEquals(int[] int1, int[] int2){
	Assert.assertEquals(int1.length, int2.length);

	for(int i = 0; i <int1.length; i++){
	    assertEquals(int1[i], int2[i]);
	}
    }

    public void assertEquals(SubFooObject sub1, SubFooObject sub2){
	assertEquals(sub1.getString(),sub2.getString());
	assertEquals(sub1.getInt(),sub2.getInt());
    }

    public Object testFile(String fileLocation, Class classToLoad)throws Exception{
	
	Loggable log = ReflectiveObjectLoaderTest.getTestLogger();

	SimpleFileIterator iter = new SimpleFileIterator(fileLocation, log);

	LoadManager manager = new SimpleFileLoadManager(iter);

	Object obj = ReflectiveObjectLoader.initializeInstance(classToLoad, manager,log);
	Assert.assertNotNull(obj);
	return obj;

    }

}
