package com.thoughtworks.rettig.dataLoader;

import java.lang.reflect.*;

public abstract class LoadableClass{
    private Class loadClass;

    public LoadableClass(Class className){
	loadClass = className;
    }

    public boolean isArray(){
	return loadClass.isArray();
    }

    public boolean equals(Class objClass){
	return loadClass.getName().equals(objClass.getName());
    }

    public String getName(){
	return loadClass.getName();
    }

    public Class getLoadClass(){
	return loadClass;
    }

    public boolean canLoad(){
	return true;
    }

    abstract public Object load();

    public boolean canRecurse(){
	return false;
    }

    public Constructor getRecursiveConstructor(){
	throw new java.lang.Error("Constructor not supported");
    }

}

