package com.thoughtworks.rettig.dataLoader;

import java.util.Hashtable;
import java.lang.reflect.*;
import com.thoughtworks.rettig.util.*;

public class SimpleFileLoadManager implements LoadManager{
    private Hashtable hash = new Hashtable();
    private SimpleFileIterator iterator;


 
    public SimpleFileLoadManager(SimpleFileIterator iter){
	this.iterator = iter;
     LoadableClass[] classes = getAllLoadables();

     for(int i =0; i< classes.length; i++){
	 hash.put(classes[i].getName(),classes[i]);
     }

    }

    public LoadableClass getLoadableForClass(Class classToLoad) {

	Object obj = hash.get(classToLoad.getName());

	if(obj == null){
	    return new FooRecursable(classToLoad);
	    //throw new java.lang.Error("No loadable class for: " + classToLoad.getName());
	}

	return (LoadableClass) obj;

    }

    public void addSupportForLoadableClass(LoadableClass classToLoad){
	hash.put(classToLoad.getName(), classToLoad);
    }


    public LoadableClass[] getAllLoadables(){
	  LoadableClass intClass = new LoadableClass(int.class){
		  public Object load() {
		      return new Integer(iterator.nextInt());
		  }
		  };

	  LoadableClass integerClass = new LoadableClass(Integer.class){
		  public Object load() {
		      return new Integer(iterator.nextInt());
		  }
		  };

	  LoadableClass stringClass = new LoadableClass(String.class){
		  public Object load() {
		      return iterator.nextString();
		  }
		  };

	  return new LoadableClass[]{
	      intClass,
	      integerClass,
	      stringClass,
	      new FooRecursable(int[].class),
	      new FooRecursable(int[][].class),
	      new FooRecursable(FooObject.class),
	      new FooRecursable(Integer[].class),
	      new FooRecursable(SubFooObject.class),
	      new FooRecursable(String[].class),
	      new FooRecursable(SubFooObject[].class)
	  };
      }

    public boolean hasMoreDataForArray(){
	return iterator.hasMoreDataForArray();
    }

}

class FooRecursable extends RecursableClass{
    public FooRecursable(Class toLoad){
	super(toLoad);
    }

    public Constructor getRecursiveConstructor() {
	return this.getLoadClass().getConstructors()[0];
    }
}



