package com.thoughtworks.rettig.loadGenerator;

import com.thoughtworks.rettig.util.SimpleFileIterator;

/**
* Used to define the implemenation for how to handle an array during the 
* source code creation process
**/
public class MethodForArray extends MethodCode{

    private final static MethodParameter iterator = new MethodParameter(SimpleFileIterator.class, "parser");

    public MethodForArray(Class className, CodeBuilder builder){
	super(className, builder);
    }

    public MethodParameter[] getInputParameters(){
       return new MethodParameter[]{
	   iterator
	   };
    }

    public MethodParameter[] getInstanceParameters(){
       return new MethodParameter[]{
	   iterator
       };
   }


    public String getMethodName(){
	      return "load" + convertToFileName(returnType.getComponentType().getName()  + "Array");
      }

    public String getReturnString(){
	    return returnType.getComponentType().getName() +"[]";
    }


    protected String getImplBody(CodeBuilder builder) {
	String body = "java.util.Vector v = new java.util.Vector();\n";
	body += "while(" + iterator.getName() + ".hasMoreDataForArray()){\n";
       	body += "v.add(" + getCall(builder, this.returnType.getComponentType())+");\n"; 
	body += "}\n";
	body += getReturnString() + " array = new " + getArrayComponent() + "[v.size()];\n";
	body += "v.copyInto(array);\n";
	body += "return array;\n";
	return body;
     }

    protected String getArrayComponent(){
      String arrayClass = this.returnType.getComponentType().getName();
      return arrayClass;
  }


}
