package com.thoughtworks.rettig.loadGenerator;

import java.lang.reflect.*;
import com.thoughtworks.rettig.util.SimpleFileIterator;

/**
* Uses reflection to dynamically create source code for an IDL defined object.
* The generated method parses data from a file into a newly created object
**/

public class MethodForInt extends MethodCode {
	private final static MethodParameter param = new MethodParameter(SimpleFileIterator.class, "parser");

	public MethodForInt(Class type, CodeBuilder builder){
		super(type, builder);
	}

	public MethodParameter[] getInputParameters(){
		return new MethodParameter[]{
			param
		};
	}

	public MethodParameter[] getInstanceParameters(){
		return getInputParameters();
	}

     	protected String getImplBody(CodeBuilder builder){
			    return "return " + param.getName() + ".nextInt();\n";
	}

}

