package com.thoughtworks.rettig.loadGenerator;

import junit.framework.*;
import com.thoughtworks.rettig.util.SimpleFileIterator;

/**
* Used to define the implemenation for how to handle an array during the 
* source code creation process
**/
public class MethodForIntArray extends MethodCode {

	private final static MethodParameter iterator = new MethodParameter(SimpleFileIterator.class, "parser");

	public MethodForIntArray(Class className, CodeBuilder builder){
		super(className, builder);
	}

	public MethodParameter[] getInputParameters(){
		return new MethodParameter[]{
			iterator
		};
	}

	public MethodParameter[] getInstanceParameters(){
		return new MethodParameter[]{
			iterator
		};
	}


	public String getMethodName(){
		return "loadIntArray";
	}

	public String getReturnString(){
		return "int[]";
	}


	protected String getImplBody(CodeBuilder builder) {

		String body = "";
		body += "\n";
		body += "java.util.Vector v = new java.util.Vector();\n";
		body += "while (parser.hasMoreDataForArray()){\n";
		body += "v.add(new Integer(parser.nextInt()));\n";
		body += "}\n";
		body += "\n";
		body += "int[] array = new int[v.size()];\n";
		body += "\n";
		body += "for(int i = 0; i < array.length; i++){\n";
		body += "Integer num = (Integer)v.get(i);\n";
		body += "array[i] = num.intValue();\n";
		body += "}\n";
		body += "\n";
		body += "return array;\n";
		return body;
	}

	protected String getArrayComponent(){
		String arrayClass = this.returnType.getComponentType().getName();
		return arrayClass;
	}


}

