package com.thoughtworks.rettig.loadGenerator;


/**
* A parameter that is required for a method. Contains
* several convenience methods to make code generation easier and cleaner.
**/
public class MethodParameter {
	private final Class type;
	private final String name;

	public MethodParameter(Class typeClass, String varName){
		this.type = typeClass;
		this.name = varName;
	}

	public Class getType(){
	    return type;
	}

	public String getSignature(){
		return type.getName() + " " + name;
	}

	public String getName(){
	    return name;
	}

	public String getTypeName(){
	    if(type.isArray()){
		return type.getComponentType().getName() + "[]";
	    }
	    return type.getName();
	}
}

