package com.thoughtworks.rettig.util;

import java.util.StringTokenizer;
import java.io.*;
import java.util.*;
import com.thoughtworks.rettig.util.RecordToker;

public class SimpleFileIterator{

	private RecordToker toker;
	final private String[] lines;
	private int lineNumber = 0;
	private Loggable log;

	public SimpleFileIterator(String fileName, Loggable theLog)throws IOException{
		this(fileName);
		log = theLog;
	}

	public SimpleFileIterator(String fileName)throws IOException{

		FileReader fr = new FileReader(fileName);
		BufferedReader br = new BufferedReader(fr);
		String line = br.readLine();
		Vector lineCollector = new Vector();
		while (line != null) {
			lineCollector.add(line);
			line = br.readLine();
		}
		br.close();
		lines = new String[lineCollector.size()];
		lineCollector.copyInto(lines);
		loadNextRecord();
		this.log = new Loggable(){
				public void logMsg(int level, String msg) {
					//System.out.println(msg);
				}
				};
		}
	public void reset(){
	    this.lineNumber = 0;
	}
	private void loadNextRecord(){
	    toker = new RecordToker(lines[lineNumber]);
	    lineNumber++;
	}
	
	public boolean hasMoreDataForArray() {
	    if( lineNumber +1 < lines.length){
		loadNextRecord();
		//System.out.println(lines[lineNumber-1]);
    		if(lines[lineNumber-1].startsWith("ARRAY")){
		    log.logMsg(log.DEBUG, "Found entry for array");
		    //loadNextRecord();    
		    return hasMoreDataForArray();
		}
		else if(lines[lineNumber-1].startsWith("END")){
		    loadNextRecord();
		    return false;
		}
		else{
		    log.logMsg(log.DEBUG, "Has More Data for array");
		    //loadNextRecord();
		    return true;
		}
	    }
	    return false;
	}

	public String nextString() {
		log.logMsg(log.DEBUG, "requesting String");
		if(toker.hasNext()){
		    return toker.nextToken();
		}
		else{
		    loadNextRecord();
		    return nextString();
		}
	}
	public int nextInt() {
		log.logMsg(log.DEBUG, "Requesting int");
		return Integer.parseInt(nextString());;
	}
}





